﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace TheMovieDB
{
    [XmlType("movie")]
    public class TmdbMovie
    {
        [XmlElement("popularity")]
        public decimal Popularity { get; set; }

        [XmlElement("name")]
        public string Name { get; set; }

        [XmlElement("alternative_name")]
        public string AlternativeName { get; set; }

        [XmlElement("type")]
        public string Type { get; set; }

        [XmlElement("id")]
        public int Id { get; set; }

        [XmlElement("imdb_id")]
        public string ImdbId { get; set; }

        [XmlElement("url")]
        public string Url { get; set; }

        [XmlElement("overview")]
        public string Overview { get; set; }

        [XmlElement("rating")]
        public decimal Rating { get; set; }

        [XmlElement("released")]
        public string ReleasedString { get; set; }

        public DateTime? Released
        {
            get
            {
                DateTime d;
                if (string.IsNullOrEmpty(ReleasedString) || !DateTime.TryParse(ReleasedString, out d))
                    return null;
                else
                    return d;
            }
        }

        [XmlElement("runtime")]
        public int Runtime { get; set; }

        [XmlElement("budget")]
        public decimal Budget { get; set; }

        [XmlElement("revenue")]
        public decimal Revenue { get; set; }

        [XmlElement("homepage")]
        public string Homepage { get; set; }

        [XmlElement("trailer")]
        public string Trailer { get; set; }

        [XmlArrayAttribute("categories")]
        public TmdbCategory[] Categories { get; set; }

        [XmlArrayAttribute("studios")]
        public TmdbStudio[] Studios { get; set; }

        [XmlArrayAttribute("countries")]
        public TmdbCountry[] Countries { get; set; }

        [XmlArrayAttribute("images")]
        public TmdbImage[] Images { get; set; }

        [XmlArrayAttribute("cast")]
        public TmdbCastPerson[] Cast { get; set; }
    }
}
